import{s as sa,f as lt,o as na}from"../chunks/scheduler.37c15a92.js";import{S as la,i as ia,g as i,s as n,r as ot,m as g,H as pt,A as oa,h as o,f as a,c as l,j as y,u as rt,x as p,n as v,B as ut,k as c,y as r,a as s,v as ct,d as mt,t as ht,w as ft}from"../chunks/index.7cb9c9b8.js";import{T as pa}from"../chunks/Tip.d10b3fc9.js";import{H as _e,E as ra}from"../chunks/EditOnGithub.858acfec.js";function ua(gt){let u;return{c(){u=g("But what does it mean to act according to our policy? After all, we don't have a policy in value-based methods since we train a value function and not a policy.")},l(f){u=v(f,"But what does it mean to act according to our policy? After all, we don't have a policy in value-based methods since we train a value function and not a policy.")},m(f,x){s(f,u,x)},d(f){f&&a(u)}}}function ca(gt){let u,f,x,vt,_,dt,b,be="In value-based methods, <strong>we learn a value function</strong> that <strong>maps a state to the expected value of being at that state.</strong>",wt,T,Te,yt,M,Me="The value of a state is the <strong>expected discounted return</strong> the agent can get if it <strong>starts at that state and then acts according to our policy.</strong>",xt,d,_t,L,Le="Remember that the goal of an <strong>RL agent is to have an optimal policy π*.</strong>",bt,$,$e="To find the optimal policy, we learned about two different methods:",Tt,H,He="<li><em>Policy-based methods:</em> <strong>Directly train the policy</strong> to select what action to take given a state (or a probability distribution over actions at that state). In this case, we <strong>don’t have a value function.</strong></li>",Mt,C,Ce,Lt,k,ke="The policy takes a state as input and outputs what action to take at that state (deterministic policy: a policy that output one action given a state, contrary to stochastic policy that output a probability distribution over actions).",$t,P,Pe="And consequently, <strong>we don’t define by hand the behavior of our policy; it’s the training that will define it.</strong>",Ht,I,Ie="<li><em>Value-based methods:</em> <strong>Indirectly, by training a value function</strong> that outputs the value of a state or a state-action pair. Given this value function, our policy <strong>will take an action.</strong></li>",Ct,G,Ge="Since the policy is not trained/learned, <strong>we need to specify its behavior.</strong> For instance, if we want a policy that, given the value function, will take actions that always lead to the biggest reward, <strong>we’ll create a Greedy Policy.</strong>",kt,E,Ee='<img src="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit3/two-approaches-3.jpg" alt="Two RL approaches"/> <figcaption>Given a state, our action-value function (that we train) outputs the value of each action at that state. Then, our pre-defined Greedy Policy selects the action that will yield the highest value given a state or a state action pair.</figcaption>',Pt,S,Se="Consequently, whatever method you use to solve your problem, <strong>you will have a policy</strong>. In the case of value-based methods, you don’t train the policy: your policy <strong>is just a simple pre-specified function</strong> (for instance, the Greedy Policy) that uses the values given by the value-function to select its actions.",It,j,je="So the difference is:",Gt,q,qe="<li>In policy-based training, <strong>the optimal policy (denoted π*) is found by training the policy directly.</strong></li> <li>In value-based training, <strong>finding an optimal value function (denoted Q* or V*, we’ll study the difference below) leads to having an optimal policy.</strong></li>",Et,A,Ae,St,z,ze="In fact, most of the time, in value-based methods, you’ll use <strong>an Epsilon-Greedy Policy</strong> that handles the exploration/exploitation trade-off; we’ll talk about this when we talk about Q-Learning in the second part of this unit.",jt,R,Re="As we mentioned above, we have two types of value-based functions:",qt,F,At,U,Fe="We write the state value function under a policy π like this:",zt,B,Ue,Rt,N,Be="For each state, the state-value function outputs the expected return if the agent <strong>starts at that state</strong> and then follows the policy forever afterward (for all future timesteps, if you prefer).",Ft,O,Ne='<img src="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit3/state-value-function-2.jpg" alt="State value function"/> <figcaption>If we take the state with value -7: it&#39;s the expected return starting at that state and taking actions according to our policy (greedy policy), so right, right, right, down, down, right, right.</figcaption>',Ut,V,Bt,W,Oe="In the action-value function, for each state and action pair, the action-value function <strong>outputs the expected return</strong> if the agent starts in that state, takes that action, and then follows the policy forever after.",Nt,m,me,Ot,Ye='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mi>a</mi></mrow><annotation encoding="application/x-tex">a</annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:0.4306em;"></span><span class="mord mathnormal">a</span></span></span></span>',Vt,Wt,Ze='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mi>s</mi></mrow><annotation encoding="application/x-tex">s</annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:0.4306em;"></span><span class="mord mathnormal">s</span></span></span></span>',Qt,Dt,ta='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mi>π</mi></mrow><annotation encoding="application/x-tex">π</annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:0.4306em;"></span><span class="mord mathnormal" style="margin-right:0.03588em;">π</span></span></span></span>',Jt,Kt,Q,Ve,Xt,D,We,Yt,J,Qe="We see that the difference is:",Zt,w,at,he,st,fe,te,ea='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><msub><mi>S</mi><mi>t</mi></msub></mrow><annotation encoding="application/x-tex">S_t</annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:0.8333em;vertical-align:-0.15em;"></span><span class="mord"><span class="mord mathnormal" style="margin-right:0.05764em;">S</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.2806em;"><span style="top:-2.55em;margin-left:-0.0576em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mathnormal mtight">t</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span></span></span></span>',ge,nt,ve,K,de,ee,aa='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><msub><mi>S</mi><mi>t</mi></msub><mo separator="true">,</mo><msub><mi>A</mi><mi>t</mi></msub></mrow><annotation encoding="application/x-tex">S_t, A_t</annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:0.8778em;vertical-align:-0.1944em;"></span><span class="mord"><span class="mord mathnormal" style="margin-right:0.05764em;">S</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.2806em;"><span style="top:-2.55em;margin-left:-0.0576em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mathnormal mtight">t</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span><span class="mpunct">,</span><span class="mspace" style="margin-right:0.1667em;"></span><span class="mord"><span class="mord mathnormal">A</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.2806em;"><span style="top:-2.55em;margin-left:0em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mathnormal mtight">t</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span></span></span></span>',ae,se,X,De='<img src="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit3/two-types.jpg" alt="Two types of value function"/> <figcaption>Note: We didn&#39;t fill all the state-action pairs for the example of Action-value function</figcaption>',ne,Y,Je="In either case, whichever value function we choose (state-value or action-value function), <strong>the returned value is the expected return.</strong>",le,Z,Ke="However, the problem is that <strong>to calculate EACH value of a state or a state-action pair, we need to sum all the rewards an agent can get if it starts at that state.</strong>",ie,tt,Xe="This can be a computationally expensive process, and that’s <strong>where the Bellman equation comes in to help us.</strong>",oe,et,pe,it,re;return _=new _e({props:{title:"Two types of value-based methods",local:"two-types-value-based-methods",headingTag:"h1"}}),d=new pa({props:{$$slots:{default:[ua]},$$scope:{ctx:gt}}}),F=new _e({props:{title:"The state-value function",local:"state-value-function",headingTag:"h2"}}),V=new _e({props:{title:"The action-value function",local:"action-value-function",headingTag:"h2"}}),et=new ra({props:{source:"https://github.com/huggingface/deep-rl-class/blob/main/units/en/unit2/two-types-value-based-methods.mdx"}}),{c(){u=i("meta"),f=n(),x=i("p"),vt=n(),ot(_.$$.fragment),dt=n(),b=i("p"),b.innerHTML=be,wt=n(),T=i("img"),yt=n(),M=i("p"),M.innerHTML=Me,xt=n(),ot(d.$$.fragment),_t=n(),L=i("p"),L.innerHTML=Le,bt=n(),$=i("p"),$.textContent=$e,Tt=n(),H=i("ul"),H.innerHTML=He,Mt=n(),C=i("img"),Lt=n(),k=i("p"),k.textContent=ke,$t=n(),P=i("p"),P.innerHTML=Pe,Ht=n(),I=i("ul"),I.innerHTML=Ie,Ct=n(),G=i("p"),G.innerHTML=Ge,kt=n(),E=i("figure"),E.innerHTML=Ee,Pt=n(),S=i("p"),S.innerHTML=Se,It=n(),j=i("p"),j.textContent=je,Gt=n(),q=i("ul"),q.innerHTML=qe,Et=n(),A=i("img"),St=n(),z=i("p"),z.innerHTML=ze,jt=n(),R=i("p"),R.textContent=Re,qt=n(),ot(F.$$.fragment),At=n(),U=i("p"),U.textContent=Fe,zt=n(),B=i("img"),Rt=n(),N=i("p"),N.innerHTML=Be,Ft=n(),O=i("figure"),O.innerHTML=Ne,Ut=n(),ot(V.$$.fragment),Bt=n(),W=i("p"),W.innerHTML=Oe,Nt=n(),m=i("p"),me=g("The value of taking action"),Ot=new pt(!1),Vt=g(" in state"),Wt=new pt(!1),Qt=g(" under a policy"),Dt=new pt(!1),Jt=g(" is:"),Kt=n(),Q=i("img"),Xt=n(),D=i("img"),Yt=n(),J=i("p"),J.textContent=Qe,Zt=n(),w=i("ul"),at=i("li"),he=g("For the state-value function, we calculate "),st=i("strong"),fe=g("the value of a state"),te=new pt(!1),ge=n(),nt=i("li"),ve=g("For the action-value function, we calculate "),K=i("strong"),de=g("the value of the state-action pair ("),ee=new pt(!1),ae=g(" ) hence the value of taking that action at that state."),se=n(),X=i("figure"),X.innerHTML=De,ne=n(),Y=i("p"),Y.innerHTML=Je,le=n(),Z=i("p"),Z.innerHTML=Ke,ie=n(),tt=i("p"),tt.innerHTML=Xe,oe=n(),ot(et.$$.fragment),pe=n(),it=i("p"),this.h()},l(t){const e=oa("svelte-u9bgzb",document.head);u=o(e,"META",{name:!0,content:!0}),e.forEach(a),f=l(t),x=o(t,"P",{}),y(x).forEach(a),vt=l(t),rt(_.$$.fragment,t),dt=l(t),b=o(t,"P",{"data-svelte-h":!0}),p(b)!=="svelte-1d7evji"&&(b.innerHTML=be),wt=l(t),T=o(t,"IMG",{src:!0,alt:!0}),yt=l(t),M=o(t,"P",{"data-svelte-h":!0}),p(M)!=="svelte-12fd7se"&&(M.innerHTML=Me),xt=l(t),rt(d.$$.fragment,t),_t=l(t),L=o(t,"P",{"data-svelte-h":!0}),p(L)!=="svelte-1urwfmu"&&(L.innerHTML=Le),bt=l(t),$=o(t,"P",{"data-svelte-h":!0}),p($)!=="svelte-19ygivo"&&($.textContent=$e),Tt=l(t),H=o(t,"UL",{"data-svelte-h":!0}),p(H)!=="svelte-1ecrory"&&(H.innerHTML=He),Mt=l(t),C=o(t,"IMG",{src:!0,alt:!0}),Lt=l(t),k=o(t,"P",{"data-svelte-h":!0}),p(k)!=="svelte-8jz7zd"&&(k.textContent=ke),$t=l(t),P=o(t,"P",{"data-svelte-h":!0}),p(P)!=="svelte-pqtqep"&&(P.innerHTML=Pe),Ht=l(t),I=o(t,"UL",{"data-svelte-h":!0}),p(I)!=="svelte-1vmcwmn"&&(I.innerHTML=Ie),Ct=l(t),G=o(t,"P",{"data-svelte-h":!0}),p(G)!=="svelte-1erga7r"&&(G.innerHTML=Ge),kt=l(t),E=o(t,"FIGURE",{"data-svelte-h":!0}),p(E)!=="svelte-1wqg60u"&&(E.innerHTML=Ee),Pt=l(t),S=o(t,"P",{"data-svelte-h":!0}),p(S)!=="svelte-dnwvfq"&&(S.innerHTML=Se),It=l(t),j=o(t,"P",{"data-svelte-h":!0}),p(j)!=="svelte-5p6c4e"&&(j.textContent=je),Gt=l(t),q=o(t,"UL",{"data-svelte-h":!0}),p(q)!=="svelte-b6yrau"&&(q.innerHTML=qe),Et=l(t),A=o(t,"IMG",{src:!0,alt:!0}),St=l(t),z=o(t,"P",{"data-svelte-h":!0}),p(z)!=="svelte-3x2yxo"&&(z.innerHTML=ze),jt=l(t),R=o(t,"P",{"data-svelte-h":!0}),p(R)!=="svelte-1iwwx7g"&&(R.textContent=Re),qt=l(t),rt(F.$$.fragment,t),At=l(t),U=o(t,"P",{"data-svelte-h":!0}),p(U)!=="svelte-h4xllq"&&(U.textContent=Fe),zt=l(t),B=o(t,"IMG",{src:!0,alt:!0}),Rt=l(t),N=o(t,"P",{"data-svelte-h":!0}),p(N)!=="svelte-19pqeuc"&&(N.innerHTML=Be),Ft=l(t),O=o(t,"FIGURE",{"data-svelte-h":!0}),p(O)!=="svelte-ft3mq"&&(O.innerHTML=Ne),Ut=l(t),rt(V.$$.fragment,t),Bt=l(t),W=o(t,"P",{"data-svelte-h":!0}),p(W)!=="svelte-1k21qix"&&(W.innerHTML=Oe),Nt=l(t),m=o(t,"P",{});var h=y(m);me=v(h,"The value of taking action"),Ot=ut(h,!1),Vt=v(h," in state"),Wt=ut(h,!1),Qt=v(h," under a policy"),Dt=ut(h,!1),Jt=v(h," is:"),h.forEach(a),Kt=l(t),Q=o(t,"IMG",{src:!0,alt:!0}),Xt=l(t),D=o(t,"IMG",{src:!0,alt:!0}),Yt=l(t),J=o(t,"P",{"data-svelte-h":!0}),p(J)!=="svelte-1n386nk"&&(J.textContent=Qe),Zt=l(t),w=o(t,"UL",{});var ue=y(w);at=o(ue,"LI",{});var we=y(at);he=v(we,"For the state-value function, we calculate "),st=o(we,"STRONG",{});var ye=y(st);fe=v(ye,"the value of a state"),te=ut(ye,!1),ye.forEach(a),we.forEach(a),ge=l(ue),nt=o(ue,"LI",{});var xe=y(nt);ve=v(xe,"For the action-value function, we calculate "),K=o(xe,"STRONG",{});var ce=y(K);de=v(ce,"the value of the state-action pair ("),ee=ut(ce,!1),ae=v(ce," ) hence the value of taking that action at that state."),ce.forEach(a),xe.forEach(a),ue.forEach(a),se=l(t),X=o(t,"FIGURE",{"data-svelte-h":!0}),p(X)!=="svelte-74fuwd"&&(X.innerHTML=De),ne=l(t),Y=o(t,"P",{"data-svelte-h":!0}),p(Y)!=="svelte-b9olrp"&&(Y.innerHTML=Je),le=l(t),Z=o(t,"P",{"data-svelte-h":!0}),p(Z)!=="svelte-1vktjwi"&&(Z.innerHTML=Ke),ie=l(t),tt=o(t,"P",{"data-svelte-h":!0}),p(tt)!=="svelte-1edmeo9"&&(tt.innerHTML=Xe),oe=l(t),rt(et.$$.fragment,t),pe=l(t),it=o(t,"P",{}),y(it).forEach(a),this.h()},h(){c(u,"name","hf:doc:metadata"),c(u,"content",ma),lt(T.src,Te="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit3/vbm-1.jpg")||c(T,"src",Te),c(T,"alt","Value Based Methods"),lt(C.src,Ce="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit3/two-approaches-2.jpg")||c(C,"src",Ce),c(C,"alt","Two RL approaches"),lt(A.src,Ae="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit3/link-value-policy.jpg")||c(A,"src",Ae),c(A,"alt","Link between value and policy"),lt(B.src,Ue="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit3/state-value-function-1.jpg")||c(B,"src",Ue),c(B,"alt","State value function"),Ot.a=Vt,Wt.a=Qt,Dt.a=Jt,lt(Q.src,Ve="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit3/action-state-value-function-1.jpg")||c(Q,"src",Ve),c(Q,"alt","Action State value function"),lt(D.src,We="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit3/action-state-value-function-2.jpg")||c(D,"src",We),c(D,"alt","Action State value function"),te.a=null,ee.a=ae},m(t,e){r(document.head,u),s(t,f,e),s(t,x,e),s(t,vt,e),ct(_,t,e),s(t,dt,e),s(t,b,e),s(t,wt,e),s(t,T,e),s(t,yt,e),s(t,M,e),s(t,xt,e),ct(d,t,e),s(t,_t,e),s(t,L,e),s(t,bt,e),s(t,$,e),s(t,Tt,e),s(t,H,e),s(t,Mt,e),s(t,C,e),s(t,Lt,e),s(t,k,e),s(t,$t,e),s(t,P,e),s(t,Ht,e),s(t,I,e),s(t,Ct,e),s(t,G,e),s(t,kt,e),s(t,E,e),s(t,Pt,e),s(t,S,e),s(t,It,e),s(t,j,e),s(t,Gt,e),s(t,q,e),s(t,Et,e),s(t,A,e),s(t,St,e),s(t,z,e),s(t,jt,e),s(t,R,e),s(t,qt,e),ct(F,t,e),s(t,At,e),s(t,U,e),s(t,zt,e),s(t,B,e),s(t,Rt,e),s(t,N,e),s(t,Ft,e),s(t,O,e),s(t,Ut,e),ct(V,t,e),s(t,Bt,e),s(t,W,e),s(t,Nt,e),s(t,m,e),r(m,me),Ot.m(Ye,m),r(m,Vt),Wt.m(Ze,m),r(m,Qt),Dt.m(ta,m),r(m,Jt),s(t,Kt,e),s(t,Q,e),s(t,Xt,e),s(t,D,e),s(t,Yt,e),s(t,J,e),s(t,Zt,e),s(t,w,e),r(w,at),r(at,he),r(at,st),r(st,fe),te.m(ea,st),r(w,ge),r(w,nt),r(nt,ve),r(nt,K),r(K,de),ee.m(aa,K),r(K,ae),s(t,se,e),s(t,X,e),s(t,ne,e),s(t,Y,e),s(t,le,e),s(t,Z,e),s(t,ie,e),s(t,tt,e),s(t,oe,e),ct(et,t,e),s(t,pe,e),s(t,it,e),re=!0},p(t,[e]){const h={};e&2&&(h.$$scope={dirty:e,ctx:t}),d.$set(h)},i(t){re||(mt(_.$$.fragment,t),mt(d.$$.fragment,t),mt(F.$$.fragment,t),mt(V.$$.fragment,t),mt(et.$$.fragment,t),re=!0)},o(t){ht(_.$$.fragment,t),ht(d.$$.fragment,t),ht(F.$$.fragment,t),ht(V.$$.fragment,t),ht(et.$$.fragment,t),re=!1},d(t){t&&(a(f),a(x),a(vt),a(dt),a(b),a(wt),a(T),a(yt),a(M),a(xt),a(_t),a(L),a(bt),a($),a(Tt),a(H),a(Mt),a(C),a(Lt),a(k),a($t),a(P),a(Ht),a(I),a(Ct),a(G),a(kt),a(E),a(Pt),a(S),a(It),a(j),a(Gt),a(q),a(Et),a(A),a(St),a(z),a(jt),a(R),a(qt),a(At),a(U),a(zt),a(B),a(Rt),a(N),a(Ft),a(O),a(Ut),a(Bt),a(W),a(Nt),a(m),a(Kt),a(Q),a(Xt),a(D),a(Yt),a(J),a(Zt),a(w),a(se),a(X),a(ne),a(Y),a(le),a(Z),a(ie),a(tt),a(oe),a(pe),a(it)),a(u),ft(_,t),ft(d,t),ft(F,t),ft(V,t),ft(et,t)}}}const ma='{"title":"Two types of value-based methods","local":"two-types-value-based-methods","sections":[{"title":"The state-value function","local":"state-value-function","sections":[],"depth":2},{"title":"The action-value function","local":"action-value-function","sections":[],"depth":2}],"depth":1}';function ha(gt){return na(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class wa extends la{constructor(u){super(),ia(this,u,ha,ca,sa,{})}}export{wa as component};
